#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#include <clib/graphics_protos.h>
#include <graphics/gfxbase.h>
#include <hardware/custom.h>
#include <hardware/dmabits.h>

#include <exec/memory.h>

#include "old_hardware_setup.h"

extern struct GfxBase *GfxBase;
extern far struct Custom custom;

int main(void) {
  struct OldHardwareSetup oldHardwareSetup;

  void *copperlist;
  UWORD *copperlist_ptr;
  APTR *bitplane;

  oldHardware_takeOver(&oldHardwareSetup);

  custom.dmacon = DMAF_SETCLR | DMAF_COPPER | DMAF_RASTER;
  custom.dmacon = DMAF_AUDIO | DMAF_DISK | DMAF_SPRITE | DMAF_BLITTER;

  // set up a two bitplane display
  // create a copperlist
  // how do you write fonts to a bitpane?

  copperlist = AllocMem(21000, MEMF_CHIP | MEMF_CLEAR);

  FreeMem(copperlist, 21000);

  oldHardware_giveBack(&oldHardwareSetup);
}
